﻿using System.Collections.Generic;

// https://en.wikipedia.org/wiki/Petri_net
namespace PetriNet
{
	public class Net
	{
		public List<Place> Places { get; set; }
		public List<Transition> Transitions { get; set; }
		public List<Arc> Arcs { get; set; }

		public Net()
		{
			Places = new List<Place>();
			Transitions = new List<Transition>();
			Arcs = new List<Arc>();
		}
	}

	public class Node
	{
		public string Label { get; set; }
	}

	public class Place : Node
	{
		public int Tokens { get; set; }
	}

	public class Transition : Node
	{
	}

	public class Arc
	{
		// Arcs run from a place to a transition or vice versa,
		// never between places or between transitions.

		public Arc(Place input, Transition output)
		{
			Input = input;
			Output = output;
		}

		public Arc(Transition input, Place output)
		{
			Input = input;
			Output = output;
		}

		public Node Input { get; private set; }
		public Node Output { get; private set; }

		public int Multiplicity { get; set; }
	}
}